<template>
  <div>
    <v-row class="navQuestions my-4 mx-8" align="center" no-gutters>
      <v-spacer />
      <v-btn
        small
        color="primary"
        class="mr-4"
        elevation="0"
        @click="openDialog(undefined, 'newCategory')"
      >
        Adicionar Área
        <v-icon small right class="ml-3">mdi-plus</v-icon>
      </v-btn>
    </v-row>
    <v-row class="mt-n2" no-gutters>
      <v-col cols="12" class="cardStyle">
        <v-card tile class="subtitle-1" elevation="0">
          <v-card-text>
            <v-row justify="center">
              <v-col style="max-width: 30%">
                <v-text-field
                  append-icon="mdi-magnify"
                  v-model="search"
                  label="Pesquisar Áreas de Conhecimento"
                  clearable
                  clear-icon="mdi-close-circle-outline"
                  class="py-0"
                  single-line
                ></v-text-field>
              </v-col>
            </v-row>
            <v-row justify="center">
              <v-col cols="12" v-if="knowledgeArea.length == 0" align="center" class="mt-1 mb-3">
                Ops, ainda <b>não temos nenhuma</b> área de conhecimento :(
              </v-col>
              <v-col v-else cols="12" sm="11" md="8" lg="7" xl="7" class="contentP">
                <v-treeview :items="knowledgeArea" :search="search" :open="open" item-key="id">
                  <!-- PREPEND -->
                  <template v-slot:prepend="{ item, open }">
                    <v-icon color="grey" v-if="open && !item.noData">mdi-folder-open</v-icon>
                    <v-icon color="grey" v-if="!open && !item.noData">mdi-folder</v-icon>
                  </template>
                  <!-- LABEL -->
                  <template slot="label" slot-scope="{ item }">
                    <span v-if="!item.noData" style="cursor: pointer" @click="openNode(item)">{{
                      item.name
                    }}</span>
                    <span class="grey--text text--darken-1" v-else
                      ><i>{{ item.name }}</i></span
                    >
                  </template>
                  <!-- Actions -->
                  <template slot="append" slot-scope="{ item }">
                    <div v-if="!item.noData" class="supportIconsTable">
                      <v-tooltip color="primary" bottom>
                        <template v-slot:activator="{ on }">
                          <v-btn
                            v-on="on"
                            @click.stop="openDialog(item, 'newChildren')"
                            icon
                            x-small
                          >
                            <v-icon>mdi-plus</v-icon>
                          </v-btn>
                        </template>
                        <span>Adicionar subárea</span>
                      </v-tooltip>

                      <v-tooltip color="primary" bottom>
                        <template v-slot:activator="{ on }">
                          <v-btn v-on="on" @click.stop="openDialog(item, 'edit')" icon x-small>
                            <v-icon>mdi-pencil</v-icon>
                          </v-btn>
                        </template>
                        <span>Editar</span>
                      </v-tooltip>
                      <v-tooltip color="primary" bottom>
                        <template v-slot:activator="{ on }">
                          <v-btn
                            v-on="on"
                            v-if="!item.root"
                            @click.stop="openDialogMoveArea(item)"
                            icon
                            x-small
                          >
                            <v-icon>mdi-folder-swap</v-icon>
                          </v-btn>
                        </template>
                        <span>Mover para</span>
                      </v-tooltip>
                      <v-tooltip color="primary" bottom>
                        <template v-slot:activator="{ on }">
                          <v-btn v-on="on" @click.stop="handleDelete(item)" icon x-small>
                            <v-icon>mdi-delete</v-icon>
                          </v-btn>
                        </template>
                        <span>Deletar</span>
                      </v-tooltip>
                    </div>
                  </template>
                </v-treeview>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <ka-dialog
      :dialog="dialog"
      :editedIndex="editedIndex"
      :categoryName="categoryName"
      :page="page"
      @closeDialog="closeDialog"
      @newCategory="saveCategory"
      @newChildren="saveChildren"
      @editCategory="editCategory"
    />
    <MoveArea
      v-if="dialogMoveArea"
      :dialog="dialogMoveArea"
      :area="knowledgeArea"
      :selectedArea="areaToMove"
      @closeDialog="closeDialogMoveArea"
      @movedArea="refreshAfterMoveArea"
    />
    <!-- Confirma deletar usuario -->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="confirmDeleteQuestion"
    />
  </div>
</template>

<script>
import KaDialog from './ManageDialog.vue'
import MoveArea from './MoveArea.vue'
import Area from '../../../servicesEhq/req/areas'

export default {
  name: 'knowledgeArea',
  components: {
    KaDialog,
    MoveArea,
  },
  props: {},
  data: () => ({
    driveNav: ['img', 'website', 'javascript', 'labTic'],
    categoryName: '',
    selectedParent: undefined,
    search: null,
    knowledgeArea: [],
    initialpage: 'Exibindo todas as categorias',
    page: 'Área de Conhecimento',
    nextId: 1000,
    dialog: false,
    areaToMove: {},
    dialogMoveArea: false,
    deleteDialog: false,
    itemToDelete: undefined,
    editedIndex: 0,
    alert: {
      status: false,
      message: '',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    open: [],
    tempChildren: [],
  }),
  async created() {
    this.init()
  },
  methods: {
    openDialog(item, type) {
      if (type == 'newCategory') {
        this.categoryName = ''
        this.editedIndex = -1
      }
      if (type == 'newChildren') {
        this.categoryName = ''
        this.editedIndex = 0
      }
      if (type == 'edit') {
        this.categoryName = item.name
        this.editedIndex = 1
      }

      this.dialog = true
      this.selectedParent = item
    },

    closeDialog() {
      this.dialog = false
      this.categoryName = ''
    },

    openDialogMoveArea(item) {
      this.areaToMove = item
      this.dialogMoveArea = true
    },

    closeDialogMoveArea() {
      this.areaToMove = {}
      this.dialogMoveArea = false
    },

    //integração backend
    async init() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.readRootAreas()
        if (req.success) {
          req.data.forEach((obj) => {
            if (obj.children) {
              obj.children = []
            }
          })
          this.knowledgeArea = req.data
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    //v-tree open - método front para abrir as categorias
    async openNode(item) {
      let check = false
      let index = -1
      //1º verifica se já está aberto
      for (let i = 0; i < this.open.length; i++) {
        if (this.open[i] == item.id) {
          check = true
          index = i
          break
        }
      }
      await this.readChildren(item)
      if (check && item.children.length > 0) this.open.splice(index, 1)
      if (!check && item.children.length > 0) this.open.push(item.id)
    },

    async readChildren(parent) {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.readChildrenArea(parent.id)
        if (req.success) {
          this.tempChildren =
            req.data.children.length > 0
              ? req.data.children
              : [{ id: `${Math.random()}`, name: 'Não possui subcategorias.', noData: true }]
          this.refreshNodeAfterOpen(this.knowledgeArea, parent.id)
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    refreshNodeAfterOpen(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.refreshNodeAfterOpen(item.children, id)
        if (item.id == id) {
          if (!item.children) {
            this.$set(item, 'children', [])
          }
          item.children = this.tempChildren
        }
        return item.id
      })
      return r
    },

    // cria categoria na RAIZ
    async saveCategory(item) {
      let data = {
        name: item,
      }

      //inicia requisição para criar nova área
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.createArea(data)
        if (req.success) {
          let newCategory = req.data[0]
          this.knowledgeArea.push(newCategory)
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Área de conhecimento <b>adicionada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Atenção, <b>não foi possível criar</b> a área de conhecimento.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    // cria categoria dentro de outra
    saveChildren(item) {
      this.categoryName = item
      this.dialog = false
      this.addChild(this.selectedParent)
    },

    async addChild(item) {
      if (!item.children) {
        this.$set(item, 'children', [])
      } else {
        let check = false

        item.children.forEach((item) => {
          if (item.noData) check = true
        })

        if (check) item.children = []
      }
      const name = this.categoryName
      const daddy = this.selectedParent.id

      const subArea = { name, daddy }

      //inicia requisição para criar nova área
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.createSubArea(subArea)
        if (req.success) {
          let newChildren = req.data[0]
          item.children.push(newChildren)
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Área de conhecimento <b>adicionada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Atenção, <b>não foi possível criar</b> a área de conhecimento.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    // fim criar categoria dentro da outra

    editCategory(item) {
      const name = item
      this.categoryName = name
      this.dialog = false
      this.editItem(this.selectedParent)
    },

    async editItem(item) {
      const areaId = item.id
      const update = { name: this.categoryName }
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.updateArea(areaId, update)
        if (req.success) {
          this.knowledgeArea = this.filterToEdit(this.knowledgeArea, item.id)
          this.closeDialog()

          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Área de conhecimento <b>editada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Atenção, <b>não foi possível editar</b> a área de conhecimento.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    refreshAfterMoveArea() {
      this.dialogMoveArea = false
      this.open = []
      this.init()
    },

    filterToEdit(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.filterToEdit(item.children, id)
        if (item.id == id) {
          item.name = this.categoryName
          // item.name = 'fez requisição'
        }
        return item.id
      })
      return r
    },

    handleDelete(item) {
      this.alert.status = true
      this.alert.message = `Deseja <b>deletar</b> a área ${item.name}?`
      this.itemToDelete = item
    },

    async confirmDeleteQuestion() {
      console.log(this.itemToDelete, 'item para deltar')
      this.alert.status = false

      const areaId = this.itemToDelete.id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let req = await Area.deleteArea(areaId)
        if (req.success) {
          this.knowledgeArea = this.filterToDelete(this.knowledgeArea, this.itemToDelete.id)
          //arrumar os abertos na arvore
          let index = -1
          //1º verifica se já está aberto
          for (let i = 0; i < this.open.length; i++) {
            if (this.open[i] == this.itemToDelete.id) {
              index = i
              break
            }
          }
          if (this.open.length > 0) this.open.splice(index, 1)

          this.closeDialog()

          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Área de conhecimento <b>deletada</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          this.closeDialog()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Atenção, <b>não foi possível deletar</b> a área de conhecimento.`,
            icon: 'mdi-close-circle',
            color: 'red',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    filterToDelete(data, id) {
      var r = data.filter((item) => {
        if (item.children) item.children = this.filterToDelete(item.children, id)
        return item.id != id
      })
      return r
    },
  },
}
</script>
<style>
.searchStyle {
  transform: scale(0.9);
}

.iconTitle {
  padding-top: 15px;
}
.contentP {
  padding-bottom: 35px;
}
</style>
